# JeviLib
## A multifunction library for code modders, containing serialization utilities and tweening.

## What does it do?

This library holds a bunch of utilities I found necessary to create whilst I created [BW Chaos](https://boneworks.thunderstore.io/package/BWChaosDevs/BW_Chaos/), and that continues to remain useful on other projects. In these utilities are my `Prefs` system, numerous extension methods, and my serialization utilities (byte array lossless joiner and separator, `Vector3` byte converter).

JeviLib also includes many extra utilities I created because I can see others having a use for them.

## **Thanks**

- WNP78: Making FieldInjector & telling me about (and helping me with) System.Linq.Expressions, used extensively in Jevil.Patching.
- Adi: Carrying the code modding category while I waste a bunch of time fucking with Unity for Septic Survival and other things. Also bringing a seafaring misnomer to my attention.
- [Simpleflips](https://www.youtube.com/watch?v=0Dpw0VvH4m0): [Shoutouts to simpleflips](https://www.youtube.com/watch?v=JmK98ehX6rc). [Its a meme you dip](https://youtu.be/JmK98ehX6rc?t=32).

# Changelog

- ### 2.0.2 Hotfix
  - Add multiple things used in [Septic Survival](https://boneworks.thunderstore.io/package/extraes/SepticSurvival/)
  - Fix bugs in multiple areas.

- ### 2.0.1 Hotfix
  - Add a few tools for developers.
  - Improve stability & consistency. 

- ## **2.0.0**: The Support Update
  - Added new namespaces: Jevil.IMGUI, Jevil.Patching, & Jevil.Waiting
  - Improve prefs system.
  - Move & rename some things.
  - Create multiple ways of more easily dynamically supporting unreferenced assemblies
  - Add more utilities and extensions.
  - ### For a more complete change list, see the list in the [Debugging/Development build's Readme](https://boneworks.thunderstore.io/package/extraes/JeviLib_Debug/). [Or check the git changes](https://github.com/extraes/JeviLib) to everything that's changed.

## JeviLib V1.X.X

- 1.1.2
  - Fix reading Enum preferences and a log statement related to them.
  - Add another AudioSource extension for tweening.

- 1.1.1
  - Fix Enum preferences. Oops, missed this bug for this long.
  - Change docs on Utilities.GFMN

 - 1.1.0
   - Add more Tweens, like extensions for AudioTween, and RotationTween.
   - Add more Tween extension methods, like `Unique`.
   - Add `Jevil.Spawning` namespace, so far just used for spawning EarlyExits of different varieties and spawning Ammo boxes. Untested, so good luck lol.
   - BREAKING CHANGE: Use record type for PrefEntries, so field/property names have changed.

 - 1.0.1
   - Fix Thunderstore website link
   - Change some docs
   - Build release as release

 - 1.0.0
   - Initial upload